{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE ScopedTypeVariables #-}

module Shift.Server (runServer) where

import CMarkGFM (commonmarkToHtml, nodeToCommonmark, nodeToHtml)
import Control.Monad.IO.Class (MonadIO (liftIO))
import Data.Text.Lazy (fromChunks)
import Shift.CLI (ShiftOptions)
import Shift.Git (renderToNode)
import Web.Scotty (rescue, rescue, get, html, param, scotty, text)

runServer :: ShiftOptions -> IO ()
runServer options = scotty 3000 $
  get "/" $ do
    (asMarkdown :: Bool) <- param "as_markdown" `rescue` (\_ -> pure False)

    node <- liftIO $ renderToNode options

    if asMarkdown
      then text $ fromChunks [nodeToCommonmark [] Nothing node]
      else html $ fromChunks [nodeToHtml [] [] node]
